Loading...
Searching...
No Matches
rep_sink.h
Go to the documentation of this file.
/* -*- c++ -*- */
/*
* Copyright 2013,2014 Free Software Foundation, Inc.
*
* This file is part of GNU Radio.
*
* SPDX-License-Identifier: GPL-3.0-or-later
*
*/
#ifndef INCLUDED_ZEROMQ_REP_SINK_H
#define INCLUDED_ZEROMQ_REP_SINK_H
#include <gnuradio/sync_block.h>
#include <gnuradio/zeromq/api.h>
namespace gr {
namespace zeromq {
/*!
* \brief Sink the contents of a stream to a ZMQ REP socket
* \ingroup zeromq
*
* \details
* This block acts a a streaming sink for a GNU Radio flowgraph
* and writes its contents to a ZMQ REP socket. A REP socket will
* only send its contents to an attached REQ socket when it
* requests items.
*/
class ZEROMQ_API rep_sink : virtual public gr::sync_block
{
public:
typedef std::shared_ptr<rep_sink> sptr;
/*!
* \brief Return a shared_ptr to a new instance of zeromq::rep_sink.
*
* \param itemsize Size of a stream item in bytes.
* \param vlen Vector length of the input items. Note that one vector is one item.
* \param address ZMQ socket address specifier.
* \param timeout Receive timeout in milliseconds, default is 100ms, 1us increments.
* \param pass_tags Whether sink will serialize and pass tags over the link.
* \param hwm High Watermark to configure the socket to (-1 => zmq's default)
* \param bind If true this block will bind to the address, otherwise it will
* connect; the default is to bind
*/
static sptr make(size_t itemsize,
size_t vlen,
char* address,
int timeout = 100,
bool pass_tags = false,
int hwm = -1,
bool bind = true);
/*!
* \brief Return a std::string of ZMQ_LAST_ENDPOINT from the underlying ZMQ socket.
*/
virtual std::string last_endpoint() = 0;
};
} // namespace zeromq
} // namespace gr
#endif /* INCLUDED_ZEROMQ_REP_SINK_H */
gr::sync_block
synchronous 1:1 input to output with history
Definition sync_block.h:26
gr::zeromq::rep_sink
Sink the contents of a stream to a ZMQ REP socket.
Definition rep_sink.h:31
gr::zeromq::rep_sink::last_endpoint
virtual std::string last_endpoint()=0
Return a std::string of ZMQ_LAST_ENDPOINT from the underlying ZMQ socket.
gr::zeromq::rep_sink::make
static sptr make(size_t itemsize, size_t vlen, char *address, int timeout=100, bool pass_tags=false, int hwm=-1, bool bind=true)
Return a shared_ptr to a new instance of zeromq::rep_sink.
gr::zeromq::rep_sink::sptr
std::shared_ptr< rep_sink > sptr
Definition rep_sink.h:33
api.h
ZEROMQ_API
#define ZEROMQ_API
Definition gr-zeromq/include/gnuradio/zeromq/api.h:18
gr::zeromq
Definition pub_msg_sink.h:18
gr
GNU Radio logging wrapper.
Definition basic_block.h:29
sync_block.h